use thiserror::Error;

#[derive(Error, Debug)]
pub enum ProviderBuildError {
    #[error("Internal error: {0}")]
    InternalError(String),
}

pub trait Provider {
    
}

pub struct ProviderBuilder {
    base_url: String,
    api_key: Option<String>
}

impl ProviderBuilder {
    pub fn build<T>(self) -> Result<Box<T>, ProviderBuildError>
    where
        T: Provider + TryFrom<ProviderBuilder, Error = ProviderBuildError>,
    {
        Ok(Box::new(T::try_from(self)?))
    }
}